#> This function runs every tick. Use this as the main function to call other functions that should run every tick.

#> World Updates
execute if score $load CmdData matches 20.. run function version:check

#> Player related functions
execute as @a at @s run function everytick:players

#> Restore Parkour high score if necessary
execute if score $load CmdData matches 10.. unless score $updating CmdData matches 1 if entity @e[type=armor_stand,tag=ParkourAS,name="???",limit=1] if score @e[type=area_effect_cloud,tag=ParkourRecordAEC,limit=1] bestParkourTime matches 0.. if data storage craftycannoneers:parkour Name run function lobby:parkour/restore

#> Reset Parkour high score if necessary
execute if score $load CmdData matches 10.. unless score $updating CmdData matches 1 unless score @e[type=area_effect_cloud,tag=ParkourRecordAEC,limit=1] bestParkourTime matches 0.. run tellraw @a [{"text":"[","color":"dark_gray"},{"text":"!","color":"red","bold":true},{"text":"] ","color":"dark_gray"},{"text":"An error has occurred, so the Parkour leaderboard has been reset. If you see this message, ","color":"gray"},{"text":"please report!","underlined":true,"color":"red","clickEvent":{"action":"open_url","value":"https://discord.gg/X9bZgw7"},"hoverEvent":{"action":"show_text","contents":[{"text":"Report on the Zeronia Discord Server","color":"white"}]}},"\n"]
execute if score $load CmdData matches 10.. unless score @e[type=area_effect_cloud,tag=ParkourRecordAEC,limit=1] bestParkourTime matches 0.. run function lobby:parkour/resethighscore

#> Slime killing (failsafe)
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=slime] unless data entity @s Tags run kill @s

#> Particle timers
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 run function everytick:particles

#> Item related functions
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=item] at @s run function everytick:items

#> Seagulls
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=armor_stand,tag=seagull] at @s at @e[type=marker,tag=seagullSpawner,limit=1,sort=nearest] run function everytick:seagull
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=marker,tag=seagull] at @s run tp @s ~ ~ ~ ~2 ~

#> Cannons
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 run function cannons:main

#> Entity effects
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=witch] at @s run function everytick:witchfix
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 if score #loaded entityid matches 1 run function entityid:real_tick
execute if score $load CmdData matches 40.. run effect give @e[type=villager] invisibility infinite 100 true
execute if score $load CmdData matches 40.. run effect give @e[type=villager] water_breathing infinite 100 true
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 run tag @e[type=villager,predicate=game:isbaby] add baby
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=villager,tag=baby,predicate=!game:isbaby] run data merge entity @s {Age:-2147483648}
execute if score $load CmdData matches 40.. run effect give @e[type=slime] invisibility infinite 100 true
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 run kill @e[type=falling_block]
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 run kill @e[type=experience_orb]
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=arrow] at @s run function everytick:arrowkill

#> Rocks
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=marker,tag=rocktracker] at @s run function lobby:rock/tp

#> Joinpads
execute if score $load CmdData matches 10.. unless score $updating CmdData matches 1 run function lobby:joinpads/main

#> Game settings
execute if score $load CmdData matches 10.. unless score $updating CmdData matches 1 if score $gamestate CmdData matches -1 if entity @a[team=Lobby,tag=!inParkour,predicate=!game:tutorialbounds] run function lobby:customizer/controller

#> Easter Eggs
execute if score $load CmdData matches 40.. run function lobby:easteregg/loop

#> Training Island
execute if score $load CmdData matches 40.. if entity @a[team=Lobby,predicate=game:tutorialbounds] run function tutorial:loop
execute if score $load CmdData matches 40.. as @e[type=marker,tag=TutorialWarp,limit=2] at @s run function tutorial:warppads/main

#> Credits particles
execute if score $load CmdData matches 40.. as @e[type=armor_stand,tag=YZERODeco,limit=1] at @s run particle enchant ~ ~0.1 ~ 0.2 0 0.2 0.3 2 normal @a[team=Lobby,tag=!inParkour,predicate=!game:tutorialbounds]
execute if score $load CmdData matches 40.. as @e[type=armor_stand,tag=EvtemaDeco,limit=1] at @s run particle enchant ~ ~0.1 ~ 0.2 0 0.2 0.3 2 normal @a[team=Lobby,tag=!inParkour,predicate=!game:tutorialbounds]
execute if score $load CmdData matches 40.. as @e[type=armor_stand,tag=StuffyDeco,limit=1] at @s run particle enchant ~ ~0.1 ~ 0.2 0 0.2 0.3 2 normal @a[team=Lobby,tag=!inParkour,predicate=!game:tutorialbounds]

#> Ingame
execute if score $gamestate CmdData matches 3 run function game:gameend
execute if score $gamestate CmdData matches 2 run function game:ingame
execute if score $gamestate CmdData matches 2.. run function game:duringgame

#> Reset eyeclick
scoreboard players reset @a[scores={eyeclick=1..}] eyeclick

#> Cannonball displays
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 as @e[type=armor_stand,tag=CannonballDeco] run function lobby:cbdisplays/main

#> Ready Up + Countdown
execute if score $gamestate CmdData matches 0 if score $OrangeReady CmdData matches 1 unless entity @a[team=Orange] run data modify block -44 -28 0 front_text.messages[2] set value '{"extra":[{"color":"gold","text":"Orange: "},{"color":"red","text":"❌","bold":true}],"text":""}'
execute if score $gamestate CmdData matches 0..1 if score $OrangeReady CmdData matches 1 unless entity @a[team=Orange] run scoreboard players set $OrangeReady CmdData 0

execute if score $gamestate CmdData matches 0 if score $PurpleReady CmdData matches 1 unless entity @a[team=Purple] run data modify block -44 -28 0 front_text.messages[3] set value '{"extra":[{"color":"dark_purple","text":"Purple: "},{"color":"red","text":"❌","bold":true}],"text":""}'
execute if score $gamestate CmdData matches 0..1 if score $PurpleReady CmdData matches 1 unless entity @a[team=Purple] run scoreboard players set $PurpleReady CmdData 0

execute if score $gamestate CmdData matches 2.. run scoreboard players set $OrangeReady CmdData 0
execute if score $gamestate CmdData matches 2.. run scoreboard players set $PurpleReady CmdData 0

execute if score $gamestate CmdData matches 0 run function game:startgame
execute if score $gamestate CmdData matches 1 run function game:countdown
execute if score $gamestate CmdData matches 0 run scoreboard players set $Countdown CmdData 0

#> Toggle score
execute store success score $toggle CmdData if score $toggle CmdData matches 0

#> Bossbars
execute if score $gamestate CmdData matches 2.. run bossbar set lobbybar players @a[team=Lobby]
execute unless score $gamestate CmdData matches 2.. run bossbar set lobbybar players @a
execute if score $gamestate CmdData matches 3 run bossbar set lobbybar color red
execute if score $gamestate CmdData matches 3 run bossbar set lobbybar name {"text":"A game is currently ending!","bold":true,"color":"red"}

#> Failsafe for reset scoreboards
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 unless score $gamestate CmdData matches -1.. run tellraw @a [{"text":"[","color":"dark_gray"},{"text":"!","color":"red","bold":true},{"text":"] ","color":"dark_gray"},{"text":"An error has occurred, so the game has been reset to defaults. If you see this message, ","color":"gray"},{"text":"please report!","underlined":true,"color":"red","clickEvent":{"action":"open_url","value":"https://discord.gg/X9bZgw7"},"hoverEvent":{"action":"show_text","contents":[{"text":"Report on the Zeronia Discord Server","color":"white"}]}},"\n"]
execute if score $load CmdData matches 40.. unless score $updating CmdData matches 1 unless score $gamestate CmdData matches -1.. run function debug:preparerelease